BoundingBox = class('BoundingBox', nil)

function BoundingBox:initialize( x1, y1, x2, y2 )
    self:set( x1 or 0, y1 or 0, x2 or 0, y2 or 0 )
end

function BoundingBox:set( x1, y1, x2, y2 )
    self.x1 = math.min( x1, x2 )
    self.y1 = math.min( y1, y2 )
    self.x2 = math.max( x1, x2 )
    self.y2 = math.max( y1, y2 )
    self.width  = self.x2 - self.x1
    self.height = self.y2 - self.y1
end

function BoundingBox:placeAroundPosition( position )
    self.x1 = position.x - (self.width / 2)
    self.y1 = position.y - (self.height / 2)
    self.x2 = self.x1 + self.width
    self.y2 = self.y1 + self.height
end

function BoundingBox:getCenter()
    return self.x1 + self.width/2, self.y1 + self.height/2
end

function BoundingBox:isPointInside( px, py )
    if px >= self.x1 and px <= self.x2 and py >= self.y1 and py <= self.y2 then
        return true
    else
        return false
    end
end