PortRender = class('PortRender', EntityRender)

function PortRender:initialize( portController )
    --EntityRender.initialize(self)
    self.portController = portController
    -- get positions.
    self:calculatePosition()
end

function PortRender:calculatePosition()
    local edge = SystemRender.hexagonShape:getEdgeBySide( self.portController.parentSystemSide, 25 )
    local t = (1/6) + (1/5) * self.portController.parentSystem:numberOfPortsOnSide( self.portController.parentSystemSide )
    if self.portController.isMaster then
        self.x, self.y = util.lerpXY( edge[1], edge[2], edge[3], edge[4], t )
    else
        local a, b, c, d = util.reverseXY(edge[1], edge[2], edge[3], edge[4])
        self.x, self.y = util.lerpXY( a, b, c, d, t )
    end
end

function PortRender:render()
    love.graphics.push()
    love.graphics.translate( self.x, self.y )
    --
    love.graphics.setColor( 255, 0, 0 )
    love.graphics.circle( "fill", 0, 0, 5 )
    --
    love.graphics.pop()
end

function PortRender:renderLine()
    if self.portController.isMaster then
        local sisterPort = self.portController.sisterPort
        local x1, y1 = self.portController.parentSystem.systemRender:localToWorldCoords( self.x, self.y )
        local x2, y2 = sisterPort.parentSystem.systemRender:localToWorldCoords(sisterPort.portRender.x, sisterPort.portRender.y)
        love.graphics.line( x1, y1, x2, y2 )
    end
end