require 'Hexagon'

SystemRender = class('SystemRender', EntityRender)


function SystemRender:initialize( systemController, hexagonShape, systemSpacing )
    EntityRender.initialize( self )
    self.systemController = systemController
    self.hexagonShape = hexagonShape
    self.position = systemController.position:clone()
    self.systemIsInViewport = false
end

function SystemRender:render()
    -- Check if any of the systems vertices are inside the viewport.
    local currentCamera = getCurrentCamera()
    
    self.systemIsInViewport = false
    local pos = self.systemController.position
    local hexvertices = self.hexagonShape.vertices
    for i = 1, #hexvertices, 2 do
        local x, y = hexvertices[i], hexvertices[i+1]
        if currentCamera:isPointInsideViewport( pos.x + x, pos.y + y, 200 ) then
            self.systemIsInViewport = true
            break
        end
    end
    
    -- Render if the system appears in the viewport.
    if self.systemIsInViewport then
        if self.systemController.isEven then
            love.graphics.setColor(100,100,100)
        else
            love.graphics.setColor( 160, 160, 160 )
        end
    
        if GridController.instance:getSystemUnderMouse() == self.systemController then love.graphics.setColor(100,100,200) end
        self.hexagonShape:render( self.position.x, self.position.y )
        --love.graphics.print(self.systemController.gridPosition.i..", "..self.systemController.gridPosition.j, self.position.x, self.position.y)
    
        love.graphics.setColor(255,255,255)
        love.graphics.push()
        love.graphics.translate( self.position.x, self.position.y )
        --
        if currentCamera.zoom >= 0.6 then
        for i, port in ipairs(self.systemController.ports) do
            --port.portRenderer:render()
        end
        end
        --
        love.graphics.pop()
    end
end

function SystemRender:localToWorldCoords( x, y )
    return self.position.x + x, self.position.y + y
end