-- Filename: 
-- Author: Luke Perkin
-- Date: 2012-05-05

require "libs"
require "lovelibs"
require "NotificationController"
require "EntityController"
require "EntityRender"
require "Hexagon"
require "GridController"
require "SystemController"
require "PortController"
require "ProgramController"

require "tests"

-- Initialization
function love.load()
    love.graphics.setFont(love.graphics.newFont( 25 ))
    camera1 = camera( vector(16500,11200), 1/32 )
    camera1:setZoomLimits( 1/32, 1 )
    hexagon = Hexagon( 100 )

    love.graphics.setLineStyle( 'smooth' )
end

-- Logic
function love.update(dt)
	EntityController.updateInstances( dt )
	camera1:update( dt )
end

-- Rendering
function love.draw()
    --love.graphics.setBackgroundColor(255,255,255)
	love.graphics.setColor(255,255,255)
	camera1:attach()
	EntityRender.renderInstances()
	camera1:detach()
	local s = ("%s systems, %s ports, %s programs. %s fps"):format(
	    #GridController.instance.systems, 
	    #PortController.instances, 
	    #EntityController.getEntitiesByClass( ProgramController ),
	    love.timer.getFPS()
	)
	love.graphics.print( s, 10, 5 )
end

function getCurrentCamera()
    return camera1
end

-- Input
function love.keypressed()
	
end

function love.keyreleased()
	
end

function love.mousepressed( x, y, button )
    NotificationController.send("on_mouse_button_pressed", {"input"}, x, y, button)
    if button == 'r' then
        camera1:startPan()
    end
	if button == 'wu' then
	    camera1:zoomToCursor( 1.4 )
    end
    if button == 'wd' then
        camera1:zoomToCursor( 1/1.4 )
    end
end

function love.mousereleased( x, y, button )
	if button == 'r' then
	    camera1:endPan()
    end
end

function love.joystickpressed()
	
end

function love.joystickreleased()
	
end