require 'libs.init'
require 'BoundingBox'

describe["A Bounding Box"] = function()
    before = function()
        boundingBox = BoundingBox()
    end
    
    it["should have six number values"] = function()
        expect( boundingBox ).is_type( "table" )
        expect( boundingBox.x1 ).is_type( "number" )
        expect( boundingBox.y1 ).is_type( "number" )
        expect( boundingBox.x2 ).is_type( "number" )
        expect( boundingBox.y2 ).is_type( "number" )
        expect( boundingBox.width ).is_type( "number" )
        expect( boundingBox.height ).is_type( "number" )
    end  
    
    it["should update the width and height when it changes"] = function()
        boundingBox:set( 0, 0, 10, 20 )
        expect( boundingBox.width ).should_be( 10 )
        expect( boundingBox.height ).should_be( 20 )
    end
    
    it["should not have (x1, y1) points less than (x2, y2) points."] = function()
        boundingBox:set( 20, 20, 10, 10 )
        expect( boundingBox.x1 ).should_be( 10 )
        expect( boundingBox.y1 ).should_be( 10 )
        expect( boundingBox.x2 ).should_be( 20 )
        expect( boundingBox.y2 ).should_be( 20 )
    end

    it["can center around a position"] = function()
        local position = vector( 50, 50 )
        boundingBox:set( 0, 0, 20, 20 )
        boundingBox:placeAroundPosition( position )
        expect( boundingBox.x1 ).should_be( 40 )
        expect( boundingBox.x2 ).should_be( 60 )
        expect( boundingBox.y1 ).should_be( 40 )
        expect( boundingBox.y2 ).should_be( 60 )
    end
    
    it["can check if a point is inside"] = function()
        local point = vector( 50, 50 )
        boundingBox:set( 20, 20, 70, 70 )
        expect( boundingBox:isPointInside( point.x, point.y ) ).should_be( true )
    end
    
    it["can check if a point is outside"] = function()
        local point = vector( 50, 50 )
        boundingBox:set( 60, 60, 70, 70 )
        expect( boundingBox:isPointInside( point.x, point.y ) ).should_be( false )
    end

end